//#define ASM
//#define STANDALONE
#include <vs1053.h>

	.import _SpiSendReceiveMmc16
	.import _SpiSendReceiveMmc
	.import _SpiSendClocks
	.import _MmcCommand


// auto u_int16 ReadDiskSector(register __a u_int32 sector) {

	.sect code,ReadDiskSector	// 66 words	-> 38
	.export _ReadDiskSector
_ReadDiskSector:	// PROLOGUE
	// stack increased in the caller
	stx B0,(I6)+1 ; sty D0,(I6)
	stx LR0,(I6)+1 ; sty mr0,(I6)	// return address
	.import _hcShift
	ldc _hcShift,i7
	ldx (i7),d0	// 0 or 9

	/* clear the top bit of address */
	lsl a1,a1	; sty I2,(I6)
	lsr a1,a1	; stx D1,(I6)+1
	stx LE,(I6)+1 ; sty LS,(I6)
	ashl A,D0,D	; stx LC,(I6)+2		// >>9 or >>0

//     register __c0 s_int16 i;
//     register __i2 u_int16 *buffer = stream_buffer;
//     MmcCommand(17 |0x40,(sector<<hcShift));

	.import _stream_buffer
	call _MmcCommand	// cmd B0 arg D
	ldc 17|0x40,B0

//     do {
// 	i = SpiSendReceiveMmc(0xff00,8);

	ldc 32767,I2	/* timeout value */
L2:
	ldc 0xff00,A0
	call _SpiSendReceiveMmc
	ldc 8,A1

	mv i2,b0
	add b0,null,b0	; ldx (i2)-1,null
	ldc 0x00ff,B0
	jzs LE7		/* if timeout, do not overwrite sector */
	sub A0,B0,B0

	ldx (i6)+1,null
	jzs L2
	ldc 256-1,LS

	ldc _stream_buffer,I2

//     } while (i == 0xff);

	loop LS,LE7-1
	ldx (i6)-1,null

//     for (i=0; i<512; i+=2) {
// 	*buffer++ = SpiSendReceiveMmc(0xffff,16);

	call _SpiSendReceiveMmc16
	or a0,ones,a0	; ldy (I6)+1,null	//ldc 0xffff,A0

	stx A0,(I2)+1
LE7:

//     }
//     SpiSendReceiveMmc(0xffff,16);
//     SpiSendClocks();
//     SpiSendClocks();

	call _SpiSendReceiveMmc16
	or a0,ones,a0	; ldx (i6),LC	//ldc 0xffff,A0
	call _SpiSendClocks
	ldx (I6),LE ; ldy (I6),LS

//     return;

	ldx (I6)-1,D1 ; ldy (I6),I2
	ldx (I6)-1,LR0 ; ldy (I6),mr0
	jr
	ldx (I6)-1,B0 ; ldy (I6),D0

	// FUNCTION ReadDiskSector(): stack usage ~ 2 x (9 + 0) = 2 x 9 words

	.end
